function D_cl = rem_noise_GenLap(D,W,sigma,T);


[M,N]=size(D);

 % estimate parameters of the pdf of noise free wavelet coefficients
 % Laplacian model exp(-x/s)^p is assumed
 
 
 [p,s]=FindGenLapPar(D,sigma);
 
 %K=p/(2*s*gamma(1/p));
 %I=K*(s/p)*gamma(1/p)*gammainc((sigma/s)^p,1/p);
 %PrFac=(1-2*I)/(2*I)
 
 
 I=gammainc((sigma/s)^p,1/p);
 
 PrFac=(1-I)/(I);
 if(PrFac<1e-6)
     PrFac=0;
 end
 
 if(PrFac==0)
    D_cl=zeros(M,N);
else
    Lim=ceil(max(max(abs(D))));

   % Compute pdfs p(m|0) and p(m|1) in the range m=0:Lim
   [LR,pdf_m_s,pdf_m_n]=MagPDFs_varT(p,s,sigma,T,Lim);
 

   % Compute pdfs p(e|0) and p(e|1) in the range m=0:Lim
   [PR,pdf_am_s,pdf_am_n]=AverageMagPDFs(pdf_m_s,pdf_m_n,W,Lim);

    SHRINK=genlikE_shrink(D,LR,PR,W,PrFac);
    D_cl=D.*SHRINK;

end







